package fucoin.supervisor;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;

import fucoin.Wallet;
import fucoin.actions.transaction.Transaction;
import akka.actor.ActorRef;
import akka.actor.UntypedActorContext;

public class DistributedCommitedTransferRequest extends Transaction {
	private final static Random random = new Random(System.currentTimeMillis()+System.nanoTime());
	private ActorRef source;
	private ActorRef target;
	private long timeout;
	private long id;
	private List<ActorRef> answers = new LinkedList<ActorRef>();	

	public DistributedCommitedTransferRequest(ActorRef source, ActorRef target,
			long timeout) {
		this.source=source;
		this.target=target;
		this.timeout=timeout;
		this.id=random.nextLong();
	}

	@Override
	protected void onAction(ActorRef sender, ActorRef self,
			UntypedActorContext context, Wallet wallet) {
		
	}
	
	public ActorRef getSource() {
		return source;
	}
	
	public ActorRef getTarget() {
		return target;
	}
	
	public long getTimeout() {
		return timeout;
	}

	public int addPositiveAnswer(ActorRef sender) {
		answers.add(sender);
		return answers.size();
	}
	
	public List<ActorRef> getAnswers() {
		return answers;
	}

	public long getId() {
		return id;
	}
}
